import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileEmployeeCertificate,
  ProfileCertificate,
  UpdateProfileCertificate,
} from "../entities/ProfileCertificate";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileCertificateHistory } from "../entities/ProfileCertificateHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-temp/certificate")
@Tags("ProfileEmployeeCertificate")
@Security("bearerAuth")
export class ProfileCertificateEmployeeTempController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private certificateRepo = AppDataSource.getRepository(ProfileCertificate);
  private certificateHistoryRepo = AppDataSource.getRepository(ProfileCertificateHistory);

  @Get("user")
  public async getCertificateUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const record = await this.certificateRepo.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("{profileEmployeeId}")
  public async getCertificate(@Path() profileEmployeeId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_TEMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_TEMP");
    const record = await this.certificateRepo.find({
      where: { profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("admin/history/{certificateId}")
  public async certificateAdminHistory(
    @Path() certificateId: string,
    @Request() req: RequestWithUser,
  ) {
    let _workflow = await new permission().Workflow(req, certificateId, "SYS_REGISTRY_TEMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_TEMP");
    const record = await this.certificateHistoryRepo.find({
      where: {
        profileCertificateId: certificateId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{certificateId}")
  public async certificateHistory(@Path() certificateId: string) {
    const record = await this.certificateHistoryRepo.find({
      where: {
        profileCertificateId: certificateId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newCertificate(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEmployeeCertificate,
  ) {
    await new permission().PermissionUpdate(req, "SYS_REGISTRY_TEMP");
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }
    const before = null;
    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });

    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }

    const data = new ProfileCertificate();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileCertificateHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.certificateRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileCertificateId = data.id;
    await this.certificateHistoryRepo.save(history, { data: req });
    setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{certificateId}")
  public async editCertificate(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileCertificate,
    @Path() certificateId: string,
  ) {
    await new permission().PermissionUpdate(req, "SYS_REGISTRY_TEMP");
    const record = await this.certificateRepo.findOneBy({ id: certificateId });

    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    const before = structuredClone(record);
    const before_null = null;
    const history = new ProfileCertificateHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileCertificateId = certificateId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.certificateRepo.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.certificateHistoryRepo.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลใบอนุญาตประกอบวิชาชีพ
   * @summary API ลบข้อมูลใบอนุญาตประกอบวิชาชีพ
   * @param certificateId คีย์ใบอนุญาตประกอบวิชาชีพ
   */
  @Patch("update-delete/{certificateId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() certificateId: string,
  ) {
    const record = await this.certificateRepo.findOneBy({ id: certificateId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionDelete(req, "SYS_REGISTRY_TEMP");
    const before = structuredClone(record);
    const history = new ProfileCertificateHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileCertificateId = certificateId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.certificateRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.certificateHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{certificateId}")
  public async deleteCertificate(@Path() certificateId: string, @Request() req: RequestWithUser) {
    await new permission().PermissionDelete(req, "SYS_REGISTRY_TEMP");
    await this.certificateHistoryRepo.delete({
      profileCertificateId: certificateId,
    });

    const certificateResult = await this.certificateRepo.delete({
      id: certificateId,
    });

    if (certificateResult.affected == undefined || certificateResult.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
